CREATE OR REPLACE VIEW I_S_INDEXES 
AS
SELECT   TABLE_SCHEMA
,        TABLE_NAME
,        INDEX_NAME
,        INDEX_TYPE
,        IF(NON_UNIQUE, 'NO', 'YES') IS_UNIQUE
,        GROUP_CONCAT(
		CONCAT('`',COLUMN_NAME,'`')
		ORDER BY IF( INDEX_TYPE = 'BTREE' -- when BTREE then
			,   SEQ_IN_INDEX         -- column order is important
			,   0)                   -- else
		,        COLUMN_NAME              -- only column content
	) COLUMNS
FROM     information_schema.STATISTICS
GROUP BY TABLE_SCHEMA
,        TABLE_NAME
,        INDEX_NAME
,        INDEX_TYPE
,        NON_UNIQUE
;