SELECT   sql_text
FROM     (
SELECT   TABLE_SCHEMA
,        TABLE_NAME
,        EVENT_MANIPULATION
,        CONCAT(
               'DELIMITER $'
         ,'\n','CREATE TRIGGER '
         ,     '`B', LEFT(tgr.EVENT_MANIPULATION, 1), 'R_'
         ,     tgr.TABLE_NAME, '`'
         ,'\n','BEFORE ', tgr.EVENT_MANIPULATION, ' ON '
         , '`', tgr.TABLE_NAME, '`'
         ,'\n','FOR EACH ROW'
         ,'\n','block: BEGIN'
         ,'\n','    IF NOT @@foreign_key_checks THEN LEAVE block; END IF;'
         ,'\n',IF(
                   SUM(IF( RELATIONSHIP_ROLE = 'PARENT'
                       AND (   EVENT_MANIPULATION = 'DELETE'
                           AND tgr.DELETE_RULE IN ('RESTRICT', 'NO ACTION') 
                           OR  EVENT_MANIPULATION = 'UPDATE'
                           AND tgr.UPDATE_RULE IN ('RESTRICT', 'NO ACTION')
                       )
                       ,   1
                       ,   0)
                   ) > 0
               ,   CONCAT(
                    '\n','    IF '
                   ,     'EXISTS ('
                   ,     GROUP_CONCAT(
                             IF( RELATIONSHIP_ROLE = 'PARENT'
                             AND (   EVENT_MANIPULATION = 'DELETE'
                                 AND tgr.DELETE_RULE IN ('RESTRICT', 'NO ACTION') 
                                 OR  EVENT_MANIPULATION = 'UPDATE'
                                 AND tgr.UPDATE_RULE IN ('RESTRICT', 'NO ACTION')
                             )
                             ,   CONCAT(
                                  '\n','        ', 'SELECT ''`', tgr.CONSTRAINT_NAME, '`'''
                                 ,'\n','        ', 'FROM   `', tgr.RELATED_TABLE_NAME, '` c'
                                 ,'\n','        ', 'WHERE   (', tgr.CONDITION1, ')'
                                 ,     IF( EVENT_MANIPULATION = 'UPDATE'
                                       ,   CONCAT('\n','        ', 'AND NOT (', tgr.CONDITION2, ')')
                                       ,   ''
                                       )
                                 )
                             ,   ''
                             )
                         SEPARATOR '\n        UNION ALL'
                         )
                   ,'\n','    ) THEN'
                   ,'\n','        call p_child_row_exists(); -- throw an error here, child row '
                   ,'\n','    END IF;'
                   )
               ,   ''
               )
         ,     GROUP_CONCAT(
                   IF( RELATIONSHIP_ROLE = 'CHILD'
                   AND EVENT_MANIPULATION IN ('INSERT', 'UPDATE')
                   ,   CONCAT(
                        '\n', '    IF '
                       ,      'NOT (', tgr.CONDITION3, ')'
                       ,'\n', '    AND '
                       ,      IF( tgr.EVENT_MANIPULATION = 'UPDATE'
                              ,   CONCAT(tgr.CONDITION2,'\n', '    AND ')
                              ,   ''
                              )
                       ,      'NOT EXISTS ('
                       ,'\n', '        SELECT NULL'
                       ,'\n', '        FROM   `', tgr.RELATED_TABLE_NAME, '` p'
                       ,'\n', '        WHERE  ', tgr.CONDITION1
                       ,'\n', '    ) THEN'
                       ,'\n', '        call p_no_parent_row(); -- throw an error here, no parent row.'
                       ,'\n', '    END IF;'
                       )
                   ,   ''
                   )
               SEPARATOR ''
               )
         ,     GROUP_CONCAT(
                   IF(RELATIONSHIP_ROLE = 'PARENT'
                   ,   CASE 
                           WHEN EVENT_MANIPULATION = 'DELETE'
                           AND  DELETE_RULE = 'SET NULL'
                           OR   EVENT_MANIPULATION = 'UPDATE'
                           AND  UPDATE_RULE IN ('SET NULL','CASCADE') THEN
                               CONCAT(
                                '\n','    UPDATE `', tgr.RELATED_TABLE_NAME, '` c'
                               ,'\n','    SET '
                               ,     IF( EVENT_MANIPULATION = 'DELETE'
                                         OR   UPDATE_RULE = 'SET NULL' 
                                     ,   tgr.SET_NULL_CLAUSE
                                     ,   tgr.SET_VALUES_CLAUSE
                                     )
                               ,'\n','    WHERE ', tgr.CONDITION1, ';'
                               )
                           WHEN EVENT_MANIPULATION = 'DELETE'
                           AND  DELETE_RULE = 'CASCADE' THEN
                               CONCAT(
                                '\n','    DELETE'
                               ,'\n','    FROM `', tgr.RELATED_TABLE_NAME, '` c'
                               ,'\n','    WHERE ', tgr.CONDITION1, ';'
                               )
                           ELSE ''
                       END
                   ,   ''
                   )
               SEPARATOR ''
               )
         ,'\n','END;'
         ,'\n','$'
         ,'\n','DELIMITER ;'
         )     as sql_text
FROM     (
         SELECT      'CHILD'                                           RELATIONSHIP_ROLE
         ,           rcs.CONSTRAINT_SCHEMA                             TABLE_SCHEMA
         ,           rcs.TABLE_NAME                                    TABLE_NAME
         ,           emn.EVENT_MANIPULATION
         ,           rcs.DELETE_RULE
         ,           rcs.UPDATE_RULE
         ,           rcs.CONSTRAINT_SCHEMA
         ,           rcs.CONSTRAINT_NAME
         ,           rcs.UNIQUE_CONSTRAINT_SCHEMA                      RELATED_TABLE_SCHEMA
         ,           rcs.REFERENCED_TABLE_NAME                         RELATED_TABLE_NAME
         ,           GROUP_CONCAT(
                         'p.`', kcu.REFERENCED_COLUMN_NAME, '`'
                     ,   ' = '
                     ,   'NEW.`', kcu.COLUMN_NAME, '`'
                     ORDER BY kcu.ORDINAL_POSITION
                     SEPARATOR '\n AND'
                     )                                                 CONDITION1
         ,           GROUP_CONCAT(
                         'NOT OLD.`', kcu.COLUMN_NAME, '` <=> NEW.`', kcu.COLUMN_NAME, '`'
                     ORDER BY kcu.ORDINAL_POSITION
                     SEPARATOR '\nOR     '
                     )                                                 CONDITION2
         ,           GROUP_CONCAT(
                         'NEW.`', kcu.COLUMN_NAME, '` IS NULL'
                     ORDER BY kcu.ORDINAL_POSITION
                     SEPARATOR '    \nAND '
                     )                                                 CONDITION3
         ,           ''                                                SET_VALUES_CLAUSE
         ,           ''                                                SET_NULL_CLAUSE
         FROM        information_schema.REFERENTIAL_CONSTRAINTS rcs    -- child
         INNER JOIN  information_schema.KEY_COLUMN_USAGE        kcu
         ON          rcs.CONSTRAINT_SCHEMA                           = kcu.TABLE_SCHEMA
         AND         rcs.TABLE_NAME                                  = kcu.TABLE_NAME
         AND         rcs.CONSTRAINT_NAME                             = kcu.CONSTRAINT_NAME
         AND         rcs.UNIQUE_CONSTRAINT_SCHEMA                    = kcu.REFERENCED_TABLE_SCHEMA
         AND         rcs.REFERENCED_TABLE_NAME                       = kcu.REFERENCED_TABLE_NAME
         CROSS JOIN  (
                     SELECT 'INSERT' EVENT_MANIPULATION
                     UNION ALL
                     SELECT 'UPDATE'
                     ) emn
         GROUP BY    rcs.CONSTRAINT_SCHEMA
         ,           rcs.TABLE_NAME
         ,           emn.EVENT_MANIPULATION
         ,           rcs.CONSTRAINT_NAME
         UNION ALL
         SELECT      'PARENT'                                           RELATIONSHIP_ROLE
         ,           rcs.UNIQUE_CONSTRAINT_SCHEMA                      TABLE_SCHEMA
         ,           rcs.REFERENCED_TABLE_NAME                         TABLE_NAME
         ,           emn.EVENT_MANIPULATION
         ,           rcs.DELETE_RULE
         ,           rcs.UPDATE_RULE
         ,           rcs.CONSTRAINT_SCHEMA
         ,           rcs.CONSTRAINT_NAME
         ,           rcs.CONSTRAINT_SCHEMA                             RELATED_TABLE_SCHEMA
         ,           rcs.TABLE_NAME                                    RELATED_TABLE_NAME
         ,           GROUP_CONCAT(
                         'c.`', kcu.COLUMN_NAME, '`'
                     ,   ' = '
                     ,   'OLD.`', kcu.REFERENCED_COLUMN_NAME, '`'
                     ORDER BY kcu.ORDINAL_POSITION
                     SEPARATOR '\nAND    '
                     )                                                 CONDITION1
         ,           GROUP_CONCAT(
                         'OLD.`', kcu.REFERENCED_COLUMN_NAME, '` <=> NEW.`', kcu.REFERENCED_COLUMN_NAME, '`'
                     ORDER BY kcu.ORDINAL_POSITION
                     SEPARATOR '\nOR     '
                     )                                                 CONDITION2
         ,           ''                                                CONDITION3
         ,           GROUP_CONCAT(
                         '`', kcu.COLUMN_NAME, '` = NEW.`', kcu.REFERENCED_COLUMN_NAME, '`'
                     SEPARATOR '\n   ,   '
                     )                                                SET_VALUES_CLAUSE
         ,           GROUP_CONCAT(
                         '`', kcu.COLUMN_NAME, '` = NULL'
                     SEPARATOR '\n   ,   '
                     )                                                 SET_NULL_CLAUSE
         FROM        information_schema.REFERENTIAL_CONSTRAINTS rcs    -- parent
         INNER JOIN  information_schema.KEY_COLUMN_USAGE        kcu
         ON          rcs.CONSTRAINT_SCHEMA                           = kcu.TABLE_SCHEMA
         AND         rcs.TABLE_NAME                                  = kcu.TABLE_NAME
         AND         rcs.CONSTRAINT_NAME                             = kcu.CONSTRAINT_NAME
         AND         rcs.UNIQUE_CONSTRAINT_SCHEMA                    = kcu.REFERENCED_TABLE_SCHEMA
         AND         rcs.REFERENCED_TABLE_NAME                       = kcu.REFERENCED_TABLE_NAME
         CROSS JOIN  (
                     SELECT 'DELETE' EVENT_MANIPULATION
                     UNION ALL
                     SELECT 'UPDATE'
                     ) emn
         GROUP BY    rcs.CONSTRAINT_SCHEMA
         ,           rcs.TABLE_NAME
         ,           emn.EVENT_MANIPULATION
         ,           rcs.CONSTRAINT_NAME
         ) tgr
GROUP BY tgr.TABLE_SCHEMA
,        tgr.TABLE_NAME
,        tgr.EVENT_MANIPULATION
) as a
WHERE a.table_schema = schema()