select    html
from      (
select    10                     level1
,         ''                     level2
,         ''                     level3
,         0                      level4
,         0                      level5
,         concat(
                '<html>'
          ,'\n','  <head>'
          ,'\n','  </head>'
          ,'\n','  <body>'
          )                  html
union all
select    20
,         s.schema_name
,         ''
,         0
,         0
,         concat(
                '<h1>The <code>', s.schema_name, '</code> schema</h1>'
          )
from      information_schema.schemata s
union all 
select    20
,         t.table_schema
,         t.table_name
,         0
,         0
,         concat(
                '<h2>The <code>', t.table_name, '</code> table</h2>'
          ,'\n','<p>'
          ,     if(t.table_comment=''
                ,  'There is no comment available for this table'
                ,  t.table_comment
                )
          ,     '</p>'
          ,'\n','<h3>Columns</h3>'
          )
from      information_schema.tables t
union all
select    20
,         c.table_schema
,         c.table_name
,         1
,         c.ordinal_position
,         concat(
                '<h4>The <code>', c.column_name, '</code> column</h4>'
          ,'\n','<ul>'
          ,'\n','  <li>Data type: <code>', c.column_type,'</code></li>'
          ,'\n','  <li>Nullable: ', lower(c.is_nullable),'</li>'
          ,'\n',if(c.column_default is null, ''
                ,  concat(
           '\n','  <li>Default value: ', c.column_default,'</li>'
                   )
                )
          ,'\n',if(c.character_set_name is null, ''
                ,  concat(
           '\n','  <li>Character set: ', c.character_set_name,'</li>'
          ,'\n','  <li>Collation: ', c.collation_name,'</li>'
                   )
                )
          ,'\n','</ul>'
          ,'\n','<p>'
          ,     if(c.column_comment=''
                ,  'There is no comment available for this column'
                ,  c.column_comment
                )
          ,     '</p>'
          )
from      information_schema.columns c
union all
select     20
,          con.table_schema
,          con.table_name
,          2
,          col.ordinal_position
,          concat(if(col.ordinal_position=1                 
           ,   concat(
                   '<h3>Primary Key</h3>'
               ,   'The primary key of the <code>'
               ,   con.table_name
               ,   '</code> table is '
               )
           ,   ', '
           ),  '<code>', col.column_name,'</code>')
from       information_schema.table_constraints con
inner join information_schema.key_column_usage  col
on         con.table_schema    = col.table_schema
and        con.table_name      = col.table_name
and        con.constraint_type = 'PRIMARY KEY'
and        con.constraint_name = col.constraint_name
union all
select    1000
,         ''
,         ''
,         0
,         0
,         concat(
                '  </body>'
          ,'\n','</html>'
          )
) doc
where     level2 = schema() or level2 = ''
order by  level1, level2, level3, level4, level5